module wn_utils

  use vtype_module

  implicit none

  private

  public :: WNUtilsCalcDelWaveNum

  !----------------------------------------------------------------------------

contains

  !----------------------------------------------------------------------------

  subroutine WNUtilsCalcDelWaveNum( &
    & NWaveNum, w_WaveNum,   &
    & w_DelWaveNum           &
    & )

    integer     , intent(in ) :: NWaveNum
    real(dp)    , intent(in ) :: w_WaveNum   (NWaveNum)
    real(dp)    , intent(out) :: w_DelWaveNum(NWaveNum)


    ! Local variables
    !
    real(dp) :: w_WaveNumInterval(NWaveNum-1)
    integer  :: i


    do i = 1, NWaveNum-1
      w_WaveNumInterval(i) = w_WaveNum(i+1) - w_WaveNum(i)
    end do

    i = 1
    w_DelWaveNum(i) = w_WaveNumInterval(i)
    do i = 1+1, NWaveNum-1
      w_DelWaveNum(i) = ( w_WaveNumInterval(i-1) + w_WaveNumInterval(i) ) / 2.0d0
    end do
    i = NWaveNum
    w_DelWaveNum(i) = w_WaveNumInterval(i-1)


  end subroutine WNUtilsCalcDelWaveNum

  !----------------------------------------------------------------------------

end module wn_utils
